#include <stdio.h>
#include <rpc/rpc.h>
#include "cfxdr.h"

extern XDR_element xdrfile[MAX_N_XDR_FILES];

	void
#ifdef cray
	CXDRRMAT64( int *ixdrid, int *nels, float *r )

#elif defined( hpux )
	cxdrrmat64( ixdrid, nels, r )
	int    *ixdrid;
	int	*nels;
	float	*r;

#else
	cxdrrmat64_( int *ixdrid, int *nels, float *r )
#endif
{
	XDR 	*xdrs;
	u_int	actual_nels, ne;

	xdrs = xdrfile[*ixdrid].xdrs;

	if( xdrs->x_op == XDR_ENCODE ) {
		if( *nels < 0 ) {
			fprintf( stderr, "FXDR library error in call to ");
			fprintf( stderr, "write real64 array to file %s:\n",
						xdrfile[*ixdrid].filename );
			fprintf( stderr, "negative number of elements specified!\n" );
			exit( -1 );
			}
		ne = *nels;
		xdr_array( xdrs, (char **)&r, &ne, ne, 8, xdr_double );
		}
	else
		{
		ne = *nels;
		xdr_array( xdrs, (char **)&r, &actual_nels, ne, 8, xdr_double );
		if( actual_nels != *nels ) {
			fprintf( stderr, "FXDR library error!  Asked for " );
			fprintf( stderr, "%d real64 elements, but actually read %d!\n",
					*nels, actual_nels );
			fprintf( stderr, "Error occured in file %s\n", 
				xdrfile[*ixdrid].filename );
			exit( -1 );
			}
		} 
}
